#include <iostream>
#include <bits/stdc++.h>


using namespace std;

bool moguce(int o, int a, int b, int ab, int suma_o, int suma_a, int suma_b, int suma_ab)
{
    if(o>=suma_o)
    {
        o-=suma_o;
        if(o+a>=suma_a)
        {
            a-=suma_a;
            if(a<0)
            {
                o+=a;
                a=0;
            }
            if(o+b>=suma_b)
            {
                b-=suma_b;
                if(b<0)
                {
                    o+=b;
                    b=0;
                }
                if(o+b+a+ab>=suma_ab)return 1;
                return 0;

            }
            return 0;

        }
        return 0;
    }
    return 0;
}


string s[10001];
int m[1000001];


int main()
{
    std::ios::sync_with_stdio(false);
    int n;
    cin>>n;
    int o, a, b, ab;
    cin>>o>>a>>b>>ab;
    int suma_o=0;
    int suma_a=0;
    int suma_b=0;
    int suma_ab=0;
    for(int i=0; i<n; i++)
    {
        cin>>s[i]>>m[i];
        if(s[i][0]=='O')suma_o+=m[i];
        else
        if(s[i][0]=='B')suma_b+=m[i];
        else
        if(s[i][0]=='A' && s[i].size()==1)suma_a+=m[i];
        else
            suma_ab+=m[i];
    }
    //cout<<suma_o<<suma_a<<suma_b<<suma_ab;
    if(moguce(o, a, b, ab, suma_o, suma_a, suma_b, suma_ab))
    {
        int o1, a1, b1, ab1=ab;
        o1=o-suma_o;
        a1=a-suma_a;
        if(a1<0)
        {
            o1+=a1;
            a1=0;
        }
        b1=b-suma_b;
        if(b1<0)
        {
            o1+=b1;
            b1=0;
        }
        int k;
        cout<<"moguce"<<endl;
        for(int i=0; i<n; i++)
        {
            if(s[i][0]=='O')
            {
                cout<<m[i]<<0<<0<<0<<endl;
                o-=m[i];
            }
            else
                if(s[i][0]=='B')
            {
                b-=m[i];
                if(b<0)
                {
                    k=abs(b);
                    o-=k;
                    b=0;
                    cout<<k<<0<<m[i]-k<<0<<endl;
                }
                else
                cout<<0<<0<<m[i]<<0<<endl;
            }
            else
            if(s[i][0]=='A' && s[i].size()==1)
            {
                a-=m[i];
                if(a<0)
                {
                    k=abs(a);
                    o-=k;
                    a=0;
                    cout<<k<<m[i]-k<<0<<0<<endl;
                }
                else
                cout<<0<<m[i]<<0<<0<<endl;
        }
        else
        {
            if(o1<m[i])
            {
                k=m[i]-o1;
                cout<<o1;
                o1=0;
                if(a1<k)
                {
                    k-=a1;
                    cout<<a1;
                    a1=0;
                    if(b1<k)
                    {
                        k-=b1;
                        cout<<b1;
                        b1=0;
                        ab1-=k;
                        cout<<k<<endl;
                    }
                    else
                    {
                        b1-=k;
                        cout<<k<<0<<endl;
                    }


                }
                else
                {
                    a1-=k;
                    cout<<k<<0<<0<<endl;
                }

            }
            else
            {
                o1-=m[i];
                cout<<m[i]<<0<<0<<0<<endl;
            }


        }
    }
    }
    else
        cout<<"nemoguce";




}